VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Sites"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Site"
Attribute VB_Ext_KEY = "Member0" ,"Site"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private colSites As Collection

Public Function Exist(ByVal ID As SourceSiteEnum) As Boolean
Dim objSite As Site
For Each objSite In colSites
  If objSite.ID = ID Then
    Exist = True
    Exit Function
  End If
Next objSite
End Function

Public Function Add(ByVal ID As SourceSiteEnum, Title As String, URL As String, Optional MainURL As String, Optional MenuURL As String) As Site
If ID = 0 Then Exit Function
If Exist(ID) Then Exit Function
Dim objSite As Site
Set objSite = New Site
objSite.ID = ID
objSite.Title = Title
objSite.URL = URL
objSite.MainURL = MainURL
objSite.MenuURL = MenuURL
colSites.Add Key:=CStr(ID), Item:=objSite
Set Add = objSite
Set objSite = Nothing
End Function

Public Property Get Item(ByVal ID As SourceSiteEnum) As Site
Attribute Item.VB_UserMemId = 0
If Not Exist(ID) Then Exit Property
Set Item = colSites(CStr(ID))
End Property

Public Property Get Count() As Long
Count = colSites.Count
End Property

Public Sub Remove(ByVal ID As SourceSiteEnum)
If Not Exist(ID) Then Exit Sub
Call colSites.Item(CStr(ID)).Dispose
colSites.Remove CStr(ID)
End Sub

Public Sub Clear()
While colSites.Count > 0
  Call colSites.Item(1).Dispose
  colSites.Remove 1
Wend
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
Set NewEnum = colSites.[_NewEnum]
End Property

Public Sub Create()
End Sub

Public Sub Dispose()
Call Clear
End Sub

Private Sub Class_Initialize()
Set colSites = New Collection
Call Create
End Sub

Private Sub Class_Terminate()
Call Dispose
Set colSites = Nothing
End Sub
