VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Tag"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Option Explicit

Private varReadOnly As Boolean
Private varFlatMode As Boolean
Private varServiceMode As Boolean

Private varOrder As Boolean
Private varName As String
Private varDisabled As Boolean
Private varTagPosStart As Long
Private varTagPosEnd As Long
Private varTagOpen As Boolean
Private varTagOpenPosStart As Long
Private varTagOpenPosEnd As Long
Private varTagOpenHTML As String
Private varTagClose As Boolean
Private varTagClosePosStart As Long
Private varTagClosePosEnd As Long
Private varTagCloseHTML As String
Private varTagValue As Boolean
Private varTagValuePosStart As Long
Private varTagValuePosEnd As Long
Private varTagValueHTML As String
Private varText As String
Private varAttributes As TagAttributes

Private objDocument As Document
Private objHTMLStore As TextStore
Private colParent As Tags
Private colChilds As Tags
Private objParent As Tag
Private objPrev As Tag
Private objNext As Tag

Friend Property Get ReadOnly() As Boolean
ReadOnly = varReadOnly
End Property

Friend Sub SetReadOnly(ByVal NewValue As Boolean)
varReadOnly = NewValue
varAttributes.SetReadOnly varReadOnly
End Sub

Friend Property Get FlatMode() As Boolean
FlatMode = varFlatMode
End Property

Friend Sub SetFlatMode(ByVal NewValue As Boolean)
varFlatMode = NewValue
End Sub

Friend Property Get ServiceMode() As Boolean
ServiceMode = varServiceMode
End Property

Friend Sub SetServiceMode(ByVal NewValue As Boolean)
varServiceMode = NewValue
End Sub

Public Property Get Order() As Long
If Not colParent Is Nothing Then
  Order = colParent.ChildIndex(Me)
End If
End Property

Public Property Get Level() As Long
If colParent Is Nothing Then Exit Property
Dim L As Long, T As Tag
Set T = Me
Do Until T.Parent Is Nothing
  L = L + 1
  If T.Parent.ParentTag Is Nothing Then Exit Do
  Set T = T.Parent.ParentTag
Loop
Set T = Nothing
Level = L
End Property

Public Property Get Name() As String
Attribute Name.VB_UserMemId = 0
Name = varName
End Property

Public Property Let Name(ByVal NewName As String)
If varReadOnly Then Exit Property
SetName NewName
End Property

Friend Sub SetName(ByVal NewName As String)
varName = UCase$(NewName)
End Sub

Public Property Get Disabled() As Boolean
Disabled = varDisabled
End Property

Public Property Let Disabled(ByVal NewDisabled As Boolean)
If varReadOnly Then Exit Property
SetDisabled NewDisabled
End Property

Friend Sub SetDisabled(ByVal NewDisabled As Boolean)
varDisabled = NewDisabled
End Sub

Public Property Get TagOpen() As Boolean
TagOpen = varTagOpen
End Property

Friend Sub SetTagOpen(ByVal NewTagOpen As Boolean)
varTagOpen = TagOpen
End Sub

Public Property Get TagOpenPosStart() As Long
TagOpenPosStart = varTagOpenPosStart
End Property

Friend Sub SetTagOpenPosStart(ByVal NewTagOpenPosStart As Long)
varTagOpenPosStart = TagOpenPosStart
End Sub

Public Property Get TagOpenPosEnd() As Long
TagOpenPosEnd = varTagOpenPosEnd
End Property

Friend Sub SetTagOpenPosEnd(ByVal NewTagOpenPosEnd As Long)
varTagOpenPosEnd = TagOpenPosEnd
End Sub

Public Property Get TagOpenHTML() As String
If varFlatMode Then
  If varTagOpen And varTagOpenPosStart > 0 And varTagOpenPosEnd > 0 Then
    TagOpenHTML = objHTMLStore.Mid2(varTagOpenPosStart, varTagOpenPosEnd)
  End If
Else
  TagOpenHTML = varTagOpenHTML
End If
End Property

Public Property Let TagOpenHTML(ByVal NewTagOpenHTML As String)
If varReadOnly Then Exit Property
SetTagOpenHTML TagOpenHTML
End Property

Friend Sub SetTagOpenHTML(ByVal NewTagOpenHTML As String)
Dim DL As Long
If varFlatMode Then
  If varTagOpen And varTagOpenPosStart > 0 And varTagOpenPosEnd > 0 Then
    DL = Len(NewTagOpenHTML) - (varTagOpenPosEnd - varTagOpenPosStart + 1)
    objHTMLStore.Subst NewTagOpenHTML, varTagOpenPosStart, , varTagOpenPosEnd
    varTagOpenPosEnd = varTagOpenPosEnd + DL
    If varTagPosEnd > 0 Then varTagPosEnd = varTagPosEnd + DL
    If varTagClose Then
      If varTagClosePosStart > 0 Then varTagClosePosStart = varTagClosePosStart + DL
      If varTagClosePosEnd > 0 Then varTagClosePosEnd = varTagClosePosEnd + DL
    End If
    If varTagValue Then
      If varTagValuePosStart > 0 Then varTagValuePosStart = varTagValuePosStart + DL
      If varTagValuePosEnd > 0 Then varTagValuePosEnd = varTagValuePosEnd + DL
    End If
  End If
Else
  varTagOpenHTML = TagOpenHTML
End If
End Sub

Public Property Get TagClose() As Boolean
TagClose = varTagClose
End Property

Friend Sub SetTagClose(ByVal NewTagClose As Boolean)
varTagClose = TagClose
End Sub

Public Property Get TagClosePosStart() As Long
TagClosePosStart = varTagClosePosStart
End Property

Friend Sub SetTagClosePosStart(ByVal NewTagClosePosStart As Long)
varTagClosePosStart = TagClosePosStart
End Sub

Public Property Get TagClosePosEnd() As Long
TagClosePosEnd = varTagClosePosEnd
End Property

Friend Sub SetTagClosePosEnd(ByVal NewTagClosePosEnd As Long)
varTagClosePosEnd = TagClosePosEnd
End Sub

Public Property Get TagCloseHTML() As String
If varFlatMode Then
  If varTagClose And varTagClosePosStart > 0 And varTagClosePosEnd > 0 Then
    TagCloseHTML = objHTMLStore.Mid2(varTagClosePosStart, varTagClosePosEnd)
  End If
Else
  TagCloseHTML = varTagCloseHTML
End If
End Property

Public Property Let TagCloseHTML(ByVal NewTagCloseHTML As String)
If varReadOnly Then Exit Property
SetTagCloseHTML TagCloseHTML
End Property

Friend Sub SetTagCloseHTML(ByVal NewTagCloseHTML As String)
Dim DL As Long
If varFlatMode Then
  If varTagClose And varTagClosePosStart > 0 And varTagClosePosEnd > 0 Then
    DL = Len(NewTagCloseHTML) - (varTagClosePosEnd - varTagClosePosStart + 1)
    objHTMLStore.Subst NewTagCloseHTML, varTagClosePosStart, , varTagClosePosEnd
    varTagClosePosEnd = varTagClosePosEnd + DL
    If varTagPosEnd > 0 Then varTagPosEnd = varTagPosEnd + DL
    If varTagValue Then
      If varTagValuePosStart > 0 Then varTagValuePosStart = varTagValuePosStart + DL
      If varTagValuePosEnd > 0 Then varTagValuePosEnd = varTagValuePosEnd + DL
    End If
  End If
Else
  varTagCloseHTML = TagCloseHTML
End If
End Sub

Public Property Get TagValue() As Boolean
TagValue = varTagValue
End Property

Friend Sub SetTagValue(ByVal NewTagValue As Boolean)
varTagValue = TagValue
End Sub

Public Property Get TagValuePosStart() As Long
TagValuePosStart = varTagValuePosStart
End Property

Friend Sub SetTagValuePosStart(ByVal NewTagValuePosStart As Long)
varTagValuePosStart = TagValuePosStart
End Sub

Public Property Get TagValuePosEnd() As Long
TagValuePosEnd = varTagValuePosEnd
End Property

Friend Sub SetTagValuePosEnd(ByVal NewTagValuePosEnd As Long)
varTagValuePosEnd = TagValuePosEnd
End Sub

Public Property Get TagValueHTML() As String
If varFlatMode Then
  If varTagValue And varTagValuePosStart > 0 And varTagValuePosEnd > 0 Then
    TagValueHTML = objHTMLStore.Mid2(varTagValuePosStart, varTagValuePosEnd)
  End If
Else
  TagValueHTML = varTagValueHTML
End If
End Property

Public Property Let TagValueHTML(ByVal NewTagValueHTML As String)
If varReadOnly Then Exit Property
SetTagValueHTML TagValueHTML
End Property

Friend Sub SetTagValueHTML(ByVal NewTagValueHTML As String)
Dim DL As Long
If varFlatMode Then
  If varTagValue And varTagValuePosStart > 0 And varTagValuePosEnd > 0 Then
    DL = Len(NewTagValueHTML) - (varTagValuePosEnd - varTagValuePosStart + 1)
    objHTMLStore.Subst NewTagValueHTML, varTagValuePosStart, , varTagValuePosEnd
    varTagValuePosEnd = varTagValuePosEnd + DL
    If varTagPosEnd > 0 Then varTagPosEnd = varTagPosEnd + DL
    If varTagClose Then
      If varTagClosePosStart > 0 Then varTagClosePosStart = varTagClosePosStart + DL
      If varTagClosePosEnd > 0 Then varTagClosePosEnd = varTagClosePosEnd + DL
    End If
  End If
Else
  varTagValueHTML = TagValueHTML
End If
End Sub

Public Property Get Text() As String
Text = varText
End Property

Public Property Let Text(ByVal NewText As String)
If varReadOnly Then Exit Property
SetText NewText
End Property

Friend Sub SetText(ByVal NewText As String)
varText = NewText
End Sub

Public Property Get Attributes() As TagAttributes
Set Attributes = varAttributes
End Property

Friend Sub Create(Parent As Tags, Optional Document As Document, Optional ByVal FlatMode As Boolean, Optional HTMLStore As TextStore)
varFlatMode = FlatMode
Set objHTMLStore = HTMLStore
Set objDocument = Document
Set colParent = Parent
Set colChilds = New Tags
colChilds.Create Me, Document, HTMLStore
If Not colParent Is Nothing Then
  Set objParent = colParent.ParentTag
End If
Set objPrev = Nothing
Set objNext = Nothing
End Sub

Friend Sub Dispose()
If Not objHTMLStore Is Nothing Then
  Set objHTMLStore = Nothing
End If
If Not objPrev Is Nothing Then
  Set objPrev = Nothing
End If
If Not objNext Is Nothing Then
  Set objNext = Nothing
End If
If Not objParent Is Nothing Then
  Set objParent = Nothing
End If
If Not colChilds Is Nothing Then
  colChilds.Dispose
  Set colChilds = Nothing
End If
If Not objDocument Is Nothing Then
  Set objDocument = Nothing
End If
End Sub

Private Sub Class_Initialize()
Print #1, "Tag + :: " & ObjPtr(Me)
varReadOnly = True
Set varAttributes = New TagAttributes
varAttributes.SetReadOnly varReadOnly
End Sub

Private Sub Class_Terminate()
varAttributes.Clear
Set varAttributes = Nothing
Print #1, "Tag - :: " & ObjPtr(Me)
End Sub

Public Sub Remove()
If Not varServiceMode And varReadOnly Then Exit Sub
If colParent Is Nothing Then Exit Sub
colParent.RemoveMe Me
End Sub

Public Function AddNext(ByVal Name As String, Optional ByVal Disabled As Boolean = False) As Tag
If Not varServiceMode And varReadOnly Then Exit Function
If colParent Is Nothing Then Exit Function
Set AddNext = colParent.Add(Name, Disabled, colParent.ChildIndex(Me), True)
End Function

Public Function AddPrev(ByVal Name As String, Optional ByVal Disabled As Boolean = False) As Tag
If Not varServiceMode And varReadOnly Then Exit Function
If colParent Is Nothing Then Exit Function
Set AddPrev = colParent.Add(Name, Disabled, colParent.ChildIndex(Me), False)
End Function

Public Property Get Childs(Optional ByVal Name As String) As Tags
colChilds.SetFilter Name
Set Childs = colChilds
End Property

Public Property Get Parent() As Tags
Set Parent = colParent
End Property

Public Property Get ItemNext() As Tag
If colParent Is Nothing Then Exit Function
Set ItemNext = colParent.Item(colParent.ChildIndex(Me) + 1)
End Property

Public Property Get ItemPrev() As Tag
If colParent Is Nothing Then Exit Function
Set ItemPrev = colParent.Item(colParent.ChildIndex(Me) - 1)
End Property

Public Property Get ItemFirst() As Tag
If colParent Is Nothing Then Exit Function
Set ItemFirst = colParent.Item(1)
End Property

Public Property Get ItemLast() As Tag
If colParent Is Nothing Then Exit Property
Set ItemLast = colParent.Item(colParent.Count)
End Property
