VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Document"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private varReadOnly As Boolean
Private varFlatMode As Boolean

Private objHTMLStore As TextStore
Private objTags As Tags

Public Property Get Tags() As Tags
Set Tags = objTags
End Property

Public Property Get HTMLStore() As TextStore
Set HTMLStore = objHTMLStore
End Property

Public Sub CleanUp()
Dispose
End Sub

Friend Sub Create()
Set objTags = New Tags
objTags.Create Nothing, Me, objHTMLStore
objTags.SetReadOnly varReadOnly
objTags.SetFlatMode varFlatMode
End Sub

Friend Sub Dispose()
If Not objTags Is Nothing Then
  objTags.Dispose
  Set objTags = Nothing
End If
End Sub

Private Sub Class_Initialize()
Print #1, "Document + :: " & ObjPtr(Me)
varReadOnly = True
varFlatMode = True
Set objHTMLStore = New TextStore
Create
End Sub

Private Sub Class_Terminate()
Set objHTMLStore = Nothing
Print #1, "Document - :: " & ObjPtr(Me)
End Sub

Public Sub EnumTags(CallbackObject As Object, ByVal CallbackProc As String, Optional ByVal ScanDepth As Boolean = True, Optional ByVal Recurse As Boolean = True)
'CallbackProc: CurrentTag As Tag, TagDepth As Long, TotalTagIndex As Long, TotalTagCount As Long
If CallbackObject Is Nothing Or Len(CallbackProc) = 0 Then Exit Sub
Dim T As Tag, I As Long, D As Long, TI As Long, TC As Long
TC = objTags.Count(Recurse)
If TC = 0 Then
  CallByName CallbackObject, CallbackProc, VbMethod, Nothing, 0, 0, 0
  Exit Sub
End If
D = 1
Set T = objTags.Item(1)
Do Until T Is Nothing
  TI = TI + 1
  If Not CallByName(CallbackObject, CallbackProc, VbMethod, T, D, TI, TC) Then Exit Do
  If ScanDepth Then
    If T.Childs.Count = 0 Then
      If T.ItemNext Is Nothing Then
        D = D - 1
        Set T = T.Parent.ParentTag
        If Not T Is Nothing Then Set T = T.ItemNext
      Else
        Set T = T.ItemNext
      End If
    Else
      If Recurse Then
        D = D + 1
        Set T = T.Childs.Item(1)
      Else
        Set T = Nothing
      End If
    End If
  Else
    If T.ItemNext Is Nothing Then
      ***
      D = I
      Do Until T Is Nothing
        If T.ItemNext Is Nothing Then
          If T.Childs.Count = 0 Then
            I = I - 1
            Set T = T.Parent.ParentTag
          Else
            I = I + 1
            Set T = T.Childs.Item(1)
          End If
        Else
          If T.Childs.Count = 0 Then
            Set T = T.ItemNext
          Else
            I = I + 1
            Set T = T.Childs.Item(1)
          End If
        End If
        If I >= D Then Exit Do
      Loop
    Else
      Set T = T.ItemNext
    End If
  End If
Loop
Set T = Nothing
End Sub
